package sillysagiri;

import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;

import dothack.Global;

public final class Utils {
  public static int ARGB15to255(char argb15)
  {
    // Extract 5-bit ABGR;
    int a5 = ((argb15 >> 15) & 0x01);
    int b5 = ((argb15 >> 10) & 0x1F);
    int g5 = ((argb15 >> 5) & 0x1F);
    int r5 = (argb15 & 0x1F);

    // Scale the 5-bit values to 8-bit
    if (a5 == 1) a5 = 255;
    else a5 = 0;

    int r8 = (r5 * 255) / 31;
    int g8 = (g5 * 255) / 31;
    int b8 = (b5 * 255) / 31;

    return (a5 << 24) | (r8 << 16) | (g8 << 8) | b8; 
  }

  public static void Clear_Screen(Graphics gg, int r, int g, int b)
  {
    gg.setColor(r,g,b);
    gg.fillRect(0, 0, Global.app.game.getWidth(), Global.app.game.getHeight());
  }

  public static void Clear_Screen(Graphics gg, int rgb)
  {
    gg.setColor(rgb);
    gg.fillRect(0, 0, Global.app.game.getWidth(), Global.app.game.getHeight());
  }

  public static void Clear_Image(Image img, int r, int g, int b)
  {
    Graphics gg = img.getGraphics();
    gg.setColor(r,g,b);
    gg.fillRect(0, 0, img.getWidth(), img.getHeight());
  }

  public static void Clear_Image(Image img, int rgb)
  {
    Graphics gg = img.getGraphics();
    gg.setColor(rgb);
    gg.fillRect(0, 0, img.getWidth(), img.getHeight());
  }

  public static int GetScreenWidth()
  {
    return Global.app.game.getWidth();
  }

  public static int GetScreenHeight()
  {
    return Global.app.game.getHeight();
  }

  public static int clamp(int value, int min, int max) {
    return Math.max(min, Math.min(value, max));
  }

  public static float clamp(float value, float min, float max) {
    return Math.max(min, Math.min(value, max));
  }

  public static double clamp(double value, double min, double max) {
    return Math.max(min, Math.min(value, max));
  }
}
